<?php
session_start();
/*
Plugin Name: WP-Post-Counter
Plugin URI: http://www.florian-fritsch.com/wp-post-counter
Description: Counts post views of every single post, archive or page. Use [wpp_count] in posts or 'echo wpp_show_counter();' in themes
Version: 1.0
Author: Florian Fritsch
Author URI: http://www.florian-fritsch.com/wp-post-counter
*/
// 
if(!isset($_SESSION[wpp_counter_ids])) {
$_SESSION[wpp_counter_ids] = array();
}
function get_postid() {
  global $wp_query;
    $thePostID = $wp_query->post->ID;
    return $thePostID;
}
function wpp_counter_activate() {
  global $wpdb;
    $wpdb->query("ALTER TABLE $wpdb->posts ADD `wpp_count` INT NOT NULL DEFAULT '0'");
}
function wpp_get_post_counter() {
  global $wpdb;
    $id = get_postid();
    // Hole aktuellen Countwert
    $value = $wpdb->get_var("SELECT `wpp_count` FROM $wpdb->posts WHERE ID='$id'");
    return $value;
}
function wpp_update_post_counter() {
  if( is_single() || is_page() || is_archive() ) {
      global $wpdb;
        $id = get_postid();
        $newvalue = wpp_get_post_counter() + 1;
        if(!in_array($id,$_SESSION[wpp_counter_ids])) {
          $wpdb->query("UPDATE $wpdb->posts SET `wpp_count` = '$newvalue' WHERE `ID` = '$id'");
          array_push($_SESSION[wpp_counter_ids],$id);
          }
  }
} 
function wpp_show_counter() {
  global $wpdb;
      if ( $keys = get_post_custom_keys() ) {
          foreach($keys as $key) {
              $id = get_postid();
              // Hole aktuellen Countwert
              $value = $wpdb->get_var("SELECT `wpp_count` FROM $wpdb->posts WHERE ID='$id'");
              return $value;
          }
      }
}

function add_wp_notice() {
  $content = '<!-- This Website uses WP Post Counter Plugin by Florian Fritsch, www.florian-fritsch.com --->';
  echo $content;
}

add_action('wp_head', 'add_wp_notice');

// Wenn Plugin aktiviert wird, entsprechende Funktion aufrufen
add_action( 'activate_'.plugin_basename(__FILE__),   'wpp_counter_activate' );
// Plugin in die Beiträge einfügen
add_action('wp_head','wpp_get_post_counter');
add_action('wp_head','wpp_update_post_counter');
// Shortcode 
add_shortcode('wpp_count', 'wpp_get_post_counter');
?>
